<?php

App::uses('EvContactFormAppModel', 'EvContactForm.Model');

class ContactFormResponse extends EvContactFormAppModel {

	public $documentSlots = array(
		'files' => array(
			'fields' => array(),
			'slots' => -1
		)
	);

	public $belongsTo = array(
		'ContactForm' => array(
			'className' => 'EvContactForm.ContactForm'
		)
	);

	public function readForAdminView($id = null, $params = array()) {
		$data = parent::readForAdminView($id, $params);

		if ($data) {
			// unserialise and manipulate form_data data ready to display
			$formData = unserialize($data[$this->alias]['form_data']);

			if (!empty($formData)) {
				$ConfFields = [];
				if (!empty($value = $formData['contact-form-send'])) {
						$form = $this->ContactForm->field('form_data', [
							'system_name' => $value . '_form'
						]);

					$ConfFields = Configure::read('EvContactForm.forms.' . $form . '.fields');
				}

				foreach ($formData as $key => $value) {

					if (!empty($ConfFields[$key]['model']['name'])) {
						$RelatedModel = EvClassRegistry::init($ConfFields[$key]['model']['name']);

						$field = !empty($ConfFields[$key]['model']['fieldToShow']) ?
								$ConfFields[$key]['model']['fieldToShow'] : $RelatedModel->displayField;

						$value = $RelatedModel->field($field, [
							$RelatedModel->primaryKey => $value
						]);
					}

					$data[$this->alias][$key] = $value;
				}
			}
		}

		return $data;
	}
}
